<?php
header('Access-Control-Allow-Origin: *');
header('Access-Control-Allow-Methods: GET, POST, OPTIONS');
header('Access-Control-Allow-Headers: Origin, Content-Type, Accept, Authorization, X-Request-With');
//header('Access-Control-Allow-Credentials: true');

date_default_timezone_set("Asia/Kolkata");
require_once 'include/config.php';

$contentType = isset($_SERVER["CONTENT_TYPE"]) ? trim($_SERVER["CONTENT_TYPE"]) : '';
$response = array();
$cart_item = "";


function updateProductQuantity($connection, $code, $size, $quantity, $productDetails) {
	
	if (!$productDetails) {
		$productDetails = $connection->query("SELECT * FROM products WHERE product_code = '$code'")->fetch_assoc();
	}
	
	if($productDetails['product_allsize']) {
		$allSizes = explode(",", $productDetails['product_allsize']);
		$allQuantities = explode(",", $productDetails['available_quant']);
		
		foreach ($allSizes as $index => $allSize) {
			if ($size == $allSize) {
				$allQuantities[$index] = $allQuantities[$index] - $quantity;
			}
		}
		
		$finalQuantities = implode(",", $allQuantities);
		$update = $connection->query("UPDATE products SET available_quant = '$finalQuantities' WHERE product_code = '$code'");
	} else {
		$update = $connection->query("UPDATE products SET available_quant = available_quant - $quantity WHERE product_code = '$code'");
	}
}


if ($contentType === "application/json") {
	//Receive the RAW post data.
	$content = trim(file_get_contents("php://input"));
	$decoded = json_decode($content);
	
	
	$name = htmlspecialchars($connection->real_escape_string($decoded->data->name));
	$walletUsername = htmlspecialchars($connection->real_escape_string($decoded->data->walletUsername));
	$walletPhone = htmlspecialchars($connection->real_escape_string($decoded->data->walletPhone));
	$walletEmail = htmlspecialchars($connection->real_escape_string($decoded->data->walletEmail));
	$email = htmlspecialchars($connection->real_escape_string($decoded->data->email));
	$phone = htmlspecialchars($connection->real_escape_string($decoded->data->phone));
	$address = htmlspecialchars($connection->real_escape_string($decoded->data->address));
	$pincode = htmlspecialchars($connection->real_escape_string($decoded->data->pincode));
	$uniqueId = htmlspecialchars($connection->real_escape_string($decoded->data->uniqueId));
	$amount = (float)htmlspecialchars($connection->real_escape_string($decoded->data->total));
	$payment_method = htmlspecialchars($connection->real_escape_string($decoded->data->payment_method));
	$delivery_charges = htmlspecialchars($connection->real_escape_string($decoded->data->delivery_charge));
	$type = htmlspecialchars($connection->real_escape_string($decoded->data->type));
	$order_type = htmlspecialchars($connection->real_escape_string($decoded->data->order_type));

	$guest_checkout = htmlspecialchars($connection->real_escape_string($decoded->data->guest_checkout));
	$couponCode = htmlspecialchars($connection->real_escape_string($decoded->data->coupon_code));
	$couponDiscount = htmlspecialchars($connection->real_escape_string($decoded->data->coupon_amount));	
	$expected_delivery_date = htmlspecialchars($connection->real_escape_string($decoded->data->expected_delivery));
	$s_name = htmlspecialchars($connection->real_escape_string($decoded->data->s_name));
	$s_email = htmlspecialchars($connection->real_escape_string($decoded->data->s_email));
	$s_mobile = htmlspecialchars($connection->real_escape_string($decoded->data->s_mobile));

	
	$today = date('Y-m-d');
	$order_date = date('Y-m-d H:i:s');


$fdsafd = $expected_delivery_date;
// $afs = '+'.$fdsafd. 'days';

$expect_delivery = date('Y-m-d', strtotime($today.' +'.$fdsafd.' days'));

// $expect_delivery = date('Y-m-d', strtotime($afs));
	
$soProceed = false;

$totalAmount = $amount + $couponDiscount -$delivery_charges;
	


	$fetch_add = $connection->query("SELECT * FROM add_address WHERE username = '$walletUsername' and mobile='$s_mobile' and address ='$address' ");
	

	

	
	if (($payment_method == "wallet" && $guest_checkout == "true") || (empty($walletUsername) && $payment_method == "wallet")) {
		$response = array(
			"status" => 5,
			"msg" => "please select payment method again",
		);
		echo json_encode($response);
		die();
	}
	

	
	if (!empty($name) && !empty($phone) && !empty($email) && !empty($address) && !empty($uniqueId) && !empty($amount)
		&& !empty($type) && !empty($payment_method) && (!empty($walletUsername) || !empty($guest_checkout))) {
		
		if ($payment_method === "pay_u") {
			
			foreach ($decoded->cart as $cart_item) {
				
				$p_name = $cart_item->product_name;
				$p_quantity = $cart_item->product_quantity;
				$p_price = $cart_item->product_price;
				$p_code = $cart_item->product_code;
				$p_color = $cart_item->product_color;
				$p_size = $cart_item->product_size;
				$p_gst = $cart_item->product_gst;
				$p_combo = $cart_item->combo_product;
				$product_pic = $cart_item->product_pic;
				$start_date= $cart_item->product_start_date;
				$end_date= $cart_item->product_end_date;
				$appointment= $cart_item->product_appointment;
				$vendor_id= $cart_item->product_vendor;
				// $item_total_amount = doItemCalc($p_price, $p_quantity, $p_gst, $couponDiscount);
				$all_items_total_after_gst += $item_total_amount['item_total_after_gst'];
				$all_item_total_without_coupon_gst += $item_total_amount['item_total_price'];

				$productDetails = $connection->query("SELECT * FROM products WHERE product_code = '$p_code'")->fetch_assoc();
				updateProductQuantity($connection, $p_code, $p_size, $p_quantity, $productDetails);

				
				
				$sql .= "INSERT INTO order_details (name,product_code,price,quantity, combo_product, color,size,uniqueId,
					transactionId,phone,order_date,product_pic,vendor_id,gst,cancel_request) VALUES ('$p_name','$p_code','$p_price','$p_quantity', '$p_combo','$p_color',
					'$p_size','$uniqueId','$uniqueId','$phone','$order_date','$product_pic','$vendor_id','$p_gst','In Progress');";
			}
			
	
			
			
			$sql .= "INSERT INTO temporder (username, name, email, address, payment_method, phone, amount,
					total_without_coupon, gift_wrap, gift_wrap_charges, coupon_discount, coupon_code, shipping_charges, uniqueId,
					payment_status, order_status, txnid, type, order_type, reward, order_date,product_pic,product_name,boarding_start_date,boarding_end_date,vet_appointment,pincode,vendor_id,expect_delivery,s_name,s_email,s_mobile) VALUES('$walletUsername', '$name',
					'$email','$address','Pay U','$phone', '$amount','$totalAmount','', '','$couponDiscount',
					'$couponCode','$delivery_charges','$uniqueId','Not Started','Waiting Payment', '$uniqueId','App','Shopping','0','$order_date','$product_pic','$p_name','$start_date','$end_date','$appointment','$pincode','$vendor_id','$expect_delivery','$s_name','$s_email','$s_mobile');";
			if ($fetch_add->num_rows == 0) {
					
				$sql .= "INSERT INTO add_address(username,address,name,email,mobile,pin) VALUES('$walletUsername','$address','$s_name','$s_email','$s_mobile','$pincode');";	
					
				}
			$soProceed = true;
			
		} elseif ($payment_method === "wallet") {
			
			$haveBalance = $connection->query("SELECT * FROM user_wallet WHERE phone ='$walletPhone' AND
				username = '$walletUsername'");
			
			if ($haveBalance->num_rows === 1) {
				
				$walletDetails = $haveBalance->fetch_assoc();
				$currentBalance = $walletDetails['balance'];
				
				if ($currentBalance >= $amount) {
					
					foreach ($decoded->cart as $cart_item) {
						
						$p_name = $cart_item->product_name;
						$p_quantity = $cart_item->product_quantity;
						$p_price = $cart_item->product_price;
						$p_code = $cart_item->product_code;
						$p_color = $cart_item->product_color;
						$p_size = $cart_item->product_size;
						$p_gst = $cart_item->product_gst;
						$p_combo = $cart_item->combo_product;
						$product_pic = $cart_item->product_pic;
						$start_date= $cart_item->product_start_date;
						$end_date= $cart_item->product_end_date;
						$appointment= $cart_item->product_appointment;
						$vendor_id= $cart_item->product_vendor;
						// $item_total_amount = doItemCalc($p_price, $p_quantity, $p_gst, $couponDiscount);
						$all_items_total_after_gst += $item_total_amount['item_total_after_gst'];
						$all_item_total_without_coupon_gst += $item_total_amount['item_total_price'];

				$productDetails = $connection->query("SELECT * FROM products WHERE product_code = '$p_code'")->fetch_assoc();
				updateProductQuantity($connection, $p_code, $p_size, $p_quantity, $productDetails);
						
						$sql .= "INSERT INTO order_details (name,product_code,price,quantity, combo_product,color,size,uniqueId,
							transactionId, phone,order_date,product_pic,vendor_id,gst,cancel_request) VALUES ('$p_name','$p_code','$p_price','$p_quantity', '$p_combo','$p_color',
							'$p_size','$uniqueId','$uniqueId','$phone','$order_date','$product_pic','$vendor_id','$p_gst','In Progress');";
					}

				
					
					$sql .= "INSERT INTO temporder (username, name, email, address, payment_method, phone, amount,
					total_without_coupon, gift_wrap, gift_wrap_charges, coupon_discount, coupon_code, shipping_charges, uniqueId,
					payment_status, order_status, txnid, type, order_type, reward, order_date,product_pic,product_name,boarding_start_date,boarding_end_date,vet_appointment,pincode,vendor_id,expect_delivery,s_name,s_email,s_mobile) VALUES('$walletUsername', '$name',
					'$email','$address','Wallet','$phone', '$amount','$totalAmount','','',
					'$couponDiscount', '$couponCode','$delivery_charges','$uniqueId','success','In Progress', '$uniqueId','App','Shopping','0',
					'$order_date','$product_pic','$p_name','$start_date','$end_date','$appointment','$pincode','$vendor_id','$expect_delivery','$s_name','$_email','$_mobile');";
					if ($fetch_add->num_rows == 0) {
					
				$sql .= "INSERT INTO add_address(username,address,name,email,mobile,pin) VALUES('$walletUsername','$address','$s_name','$s_email','$s_mobile','$pincode');";	
					
				}
					
					$sql .= "UPDATE user_wallet SET balance = balance - '$amount' WHERE phone = '$walletPhone' AND
						username = '$walletUsername';";
					
					$soProceed = true;
				} else {
					$soProceed = false;
					$response = array(
						'status' => 3,
						'msg' => "You do not have enough balance in your wallet.",
					);
				}
			} else {
				$soProceed = false;
				$response = array(
					'status' => 4,
					'msg' => "NO wallet account found.",
				);
			}
		} elseif ($payment_method == "cod") {
			
			
			foreach ($decoded->cart as $cart_item) {
				
				$p_name = $cart_item->product_name;
				$p_quantity = $cart_item->product_quantity;
				$p_price = $cart_item->product_price;
				$p_code = $cart_item->product_code;
				$p_color = $cart_item->product_color;
				$p_size = $cart_item->product_size;
				$p_gst = $cart_item->product_gst;
				$p_combo = $cart_item->combo_product;
				$product_pic = $cart_item->product_pic;
				$start_date= $cart_item->product_start_date;
				$end_date= $cart_item->product_end_date;
				$appointment= $cart_item->product_appointment;
				$vendor_id= $cart_item->product_vendor;
				// $item_total_amount = doItemCalc($p_price, $p_quantity, $p_gst, $couponDiscount);
				$all_items_total_after_gst += $item_total_amount['item_total_after_gst'];
				$all_item_total_without_coupon_gst += $item_total_amount['item_total_price'];

			$productDetails = $connection->query("SELECT * FROM products WHERE product_code = '$p_code'")->fetch_assoc();
				updateProductQuantity($connection, $p_code, $p_size, $p_quantity, $productDetails);
				
				$sql .= "INSERT INTO order_details (name,product_code,price,quantity, combo_product,color,size,uniqueId,
					transactionId,phone,order_date,product_pic,vendor_id,gst,cancel_request) VALUES ('$p_name','$p_code','$p_price','$p_quantity','$p_combo','$p_color','$p_size','$uniqueId','$uniqueId','$phone','$order_date','$product_pic','$vendor_id','$p_gst','In Progress');";
			}

			$sql .= "INSERT INTO temporder (username, name, email, address, payment_method, phone, amount,
					total_without_coupon, gift_wrap, gift_wrap_charges, coupon_discount, coupon_code, shipping_charges, uniqueId,
					payment_status, order_status, txnid, type, order_type, reward, order_date,product_pic,product_name,boarding_start_date,boarding_end_date,vet_appointment,pincode,vendor_id,expect_delivery,s_name,s_email,s_mobile) VALUES('$walletUsername', '$name',
					'$email','$address','COD','$phone', '$amount','$totalAmount','','',
					'$couponDiscount', '$couponCode','$delivery_charges','$uniqueId','Cash On Delivery','In Progress', '$uniqueId',
					'App','Shopping','0','$order_date','$product_pic','$p_name','$start_date','$end_date','$appointment','$pincode','$vendor_id','$expect_delivery','$s_name','$s_email','$s_mobile');";

				if ($fetch_add->num_rows == 0) {
					
				$sql .= "INSERT INTO add_address(username,address,name,email,mobile,pin) VALUES('$walletUsername','$address','$s_name','$s_email','$s_mobile','$pincode');";	
					
				}

			
			$soProceed = true;
		}
		
		if ($soProceed === true) {
			
			$query = $connection->multi_query($sql);
			
			if ($query === true) {
					$tot = $amount+$delivery_charges;
					$od = $connection->insert_id;
				newOrderCustomerSMS($phone,$tot,$od);
				newOrderAdminSMS($od);
				newOrderVendorSMS($od);
				$response = array(
					"status" => 1,
					"msg" => "Success",
					"uniqueId" => $uniqueId,
					
					"orderId" => $connection->insert_id,
				);
			} else {
				$response = array(
					"status" => 2,
					"msg" => "unexpected error",
					"sql" => $sql,
				);
			}
			
		}
	} else {
		$data = array(
			"status" => 0,
			"msg" => "empty fields",
			'a' => $decoded
		);
	}
} else {
	$response = array(
		"status" => 99,
		"msg" => "unauthorised access",
	);
}
echo json_encode($response);
?>
